
#include "../timer/timer.hpp"
#include "../timer/timer.ipp"
#include "../timer/looper.hpp"

#include <iostream>

inline double do_sum()
{
	static double sum;
	static double i;

	sum = 0.0;
	for (i = 0; i < MAX_FN_LOOP ; ++i)
	{
		sum += i * i;
	}

	return sum;
}

int main()
{
	SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_TIME_CRITICAL);
	//SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_HIGHEST );
	//SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_NORMAL);
	//SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_LOWEST );
	//SetThreadPriority(GetCurrentThread(), THREAD_PRIORITY_IDLE );

	Sleep(1000);
	//matt::timer t(2.09);  // home
    //matt::timer t(3.19134);   // work
    matt::timer t;
	std::cout << "processor speed guess = " << t.estimate_frequency(11) << "\n";

	double now;

	std::cout << "---------------------------------------------------------------------\n";
	t.restart();
	now = t.elapsed();


	t.restart();
    std::cout << "quick time before overhead estimate= " << matt::time_text(now) << "\n";

	now = t.elapsed();

    std::cout << "time including previous console output = " << matt::time_text(now) << "\n";
    std::cout << "overhead estimate = " << matt::time_text(t.minimum_overhead_estimator()) << "\n";

	t.restart();
	now = t.elapsed();

	t.restart();
    std::cout << "quick time after overhead estimation = " << matt::time_text(now) << "\n";
	now = t.elapsed();


	std::cout << "time including previous console output = " << matt::time_text(now) << "\n";

	std::cout << "---------------------------------------------------------------------\n";
	std::cout << "                  new timer for checking static carry\n";
	std::cout << "---------------------------------------------------------------------\n";
	matt::timer q;
	q.restart();
	now = q.elapsed();

	std::cout << "quick time " << matt::time_text(now) << "\n";

	q.restart();
	now = q.elapsed();
	std::cout << "quick time " << matt::time_text(now) << "\n";

    std::cout << "overhead estimate = " << matt::time_text(q.minimum_overhead_estimator()) << "\n";

	q.restart();
	now = q.elapsed();

	std::cout << "quick time " << matt::time_text(now) << "\n";

	q.restart();
	now = q.elapsed();
	std::cout << "quick time " << matt::time_text(now) << "\n";


	// Real estimator
	std::cout << "---------------------------------------------------------------------\n";
	std::cout << "                  check timing jitter on a simple loop \n";
	std::cout << "---------------------------------------------------------------------\n";

	matt::looper loopy;
	//loopy.do_timings(&do_sum, 10000);

	loopy.estimate_boost_function_overhead(1000 );
	//loopy.estimate_boost_function_overhead(1000, &matt::looper::not_empty);
	//loopy.estimate_boost_function_overhead(1000, &do_sum );

	system("pause");

	return 0;
}